Add Solaris/linux support
[deliverable/binutils-gdb.git] / configure.in
... / ...
CommitLineData
1##############################################################################
2
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
7
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
12
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
15
16##############################################################################
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
28
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
39 recode release sed utils guile perl apache"
40
41
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
44#
45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
46
47
48# these tools are built using the target libs, and are intended to run only
49# in the target environment
50#
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
54#
55target_tools="target-examples target-groff"
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
63## a native environment.
64
65# directories to be built in the native environment only
66#
67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
68 indent ispell m4 rcs recode sed shellutils tar textutils gash
69 uudecode wdiff gprof target-groff guile perl apache"
70
71# directories to be built in a cross environment only
72#
73cross_only="target-libiberty target-libgloss target-newlib"
74
75## All tools belong in one of the four categories, and are assigned above
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
80#
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
83
84################################################################################
85
86srctrigger=move-if-change
87srcname="gnu development package"
88
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
92# per-host:
93
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
96case "${host}" in
97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
100 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
101 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
102 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
103 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
104 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
105 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
106 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
107 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
108 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
109 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
110 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
111 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
112 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
113 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
115 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
116 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
117 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
118 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
119 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
120 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
121 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
122 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
123 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
124 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
125 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
126 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
127 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
128 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
130esac
131fi
132
133# If we aren't going to be using gcc, see if we can extract a definition
134# of CC from the fragment.
135if [ -z "${CC}" -a "${build}" = "${host}" ]; then
136 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
137 found=
138 for dir in $PATH; do
139 test -z "$dir" && dir=.
140 if test -f $dir/gcc; then
141 found=yes
142 break
143 fi
144 done
145 IFS="$save_ifs"
146 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
147 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
148 if [ -n "${xx}" ] ; then
149 CC=$xx
150 fi
151 fi
152fi
153
154# We default to --with-shared on platforms where -fpic is meaningless.
155# Well, we don't yet, but we will.
156if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
157 case "${target}" in
158 alpha-dec-osf*) enable_shared=yes ;;
159 mips-sgi-irix5*) enable_shared=yes ;;
160 *) enable_shared=no ;;
161 esac
162fi
163
164case "${enable_shared}" in
165 yes) shared=yes ;;
166 no) shared=no ;;
167 "") shared=no ;;
168 *) shared=yes ;;
169esac
170
171if [ x${shared} = xyes ]; then
172 waugh=
173 case "${host}" in
174 hppa*) waugh=config/mh-papic ;;
175 i[345]86-*) waugh=config/mh-x86pic ;;
176 sparc64-*) waugh=config/mh-sparcpic ;;
177 *) waugh=config/mh-${host_cpu}pic ;;
178 esac
179 if [ -f ${srcdir}/${waugh} ]; then
180 if [ -n "${host_makefile_frag}" ] ; then
181 cat ${srcdir}/${host_makefile_frag} > mh-frag
182 cat ${srcdir}/${waugh} >> mh-frag
183 host_makefile_frag=mh-frag
184 else
185 host_makefile_frag=${waugh}
186 fi
187 fi
188fi
189
190# per-target:
191
192case "${target}" in
193 v810*) target_makefile_frag=config/mt-v810 ;;
194 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
195 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
196esac
197
198skipdirs=
199gasdir=gas
200use_gnu_ld=
201use_gnu_as=
202
203# some tools are so dependent upon X11 that if we're not building with X,
204# it's not even worth trying to configure, much less build, that tool.
205
206case ${with_x} in
207 yes | "") # the default value for this tree is that X11 is available
208 ;;
209 no)
210 skipdirs="${skipdirs} tk gash"
211 ;;
212 *)
213 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
214 ;;
215esac
216
217# Some tools are only suitable for building in a "native" situation.
218# Those are added when we have a host==target configuration. For cross
219# toolchains, we add some directories that should only be useful in a
220# cross-compiler.
221
222is_cross_compiler=
223
224if [ x"${host}" = x"${target}" ] ; then
225 # when doing a native toolchain, don't build the targets
226 # that are in the 'cross only' list
227 skipdirs="${skipdirs} ${cross_only}"
228 is_cross_compiler=no
229 target_subdir=.
230else
231 # similarly, don't build the targets in the 'native only'
232 # list when building a cross compiler
233 skipdirs="${skipdirs} ${native_only}"
234 is_cross_compiler=yes
235 target_subdir=${target_alias}
236 if [ ! -d ${target_subdir} ] ; then
237 if mkdir ${target_subdir} ; then true
238 else
239 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
240 exit 1
241 fi
242 fi
243fi
244
245copy_dirs=
246
247# Handle --with-headers=XXX. The contents of the named directory are
248# copied to $(tooldir)/sys-include.
249if [ x"${with_headers}" != x ]; then
250 if [ x${is_cross_compiler} = xno ]; then
251 echo 1>&2 '***' --with-headers is only supported when cross compiling
252 exit 1
253 fi
254 case "${exec_prefixoption}" in
255 "") x=${prefix} ;;
256 *) x=${exec_prefix} ;;
257 esac
258 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
259fi
260
261# Handle --with-libs=XXX. Multiple directories are permitted. The
262# contents are copied to $(tooldir)/lib.
263if [ x"${with_libs}" != x ]; then
264 if [ x${is_cross_compiler} = xno ]; then
265 echo 1>&2 '***' --with-libs is only supported when cross compiling
266 exit 1
267 fi
268 # Copy the libraries in reverse order, so that files in the first named
269 # library override files in subsequent libraries.
270 case "${exec_prefixoption}" in
271 "") x=${prefix} ;;
272 *) x=${exec_prefix} ;;
273 esac
274 for l in ${with_libs}; do
275 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
276 done
277fi
278
279# If both --with-headers and --with-libs are specified, default to
280# --without-newlib.
281if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
282 if [ x"${with_newlib}" = x ]; then
283 with_newlib=no
284 fi
285fi
286
287# Recognize --with-newlib/--without-newlib.
288if [ x${with_newlib} = xno ]; then
289 skipdirs="${skipdirs} target-newlib"
290elif [ x${with_newlib} = xyes ]; then
291 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
292fi
293
294# Default to using --with-stabs for certain targets.
295if [ x${with_stabs} = x ]; then
296 case "${target}" in
297 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
298 with_stabs=yes;
299 withoptions="${withoptions} --with-stabs"
300 ;;
301 esac
302fi
303
304# Handle ${copy_dirs}
305set fnord ${copy_dirs}
306shift
307while [ $# != 0 ]; do
308 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
309 :
310 else
311 echo Copying $1 to $2
312
313 # Use the install script to create the directory and all required
314 # parent directories.
315 if [ -d $2 ]; then
316 :
317 else
318 echo >config.temp
319 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
320 fi
321
322 # Copy the directory, assuming we have tar.
323 # FIXME: Should we use B in the second tar? Not all systems support it.
324 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
325
326 # It is the responsibility of the user to correctly adjust all
327 # symlinks. If somebody can figure out how to handle them correctly
328 # here, feel free to add the code.
329
330 echo $1 > $2/COPIED
331 fi
332 shift; shift
333done
334
335# Configure extra directories which are host specific
336
337case "${host}" in
338 i[345]86-*-go32*)
339 configdirs="$configdirs dosrel" ;;
340esac
341
342# Remove more programs from consideration, based on the host or
343# target this usually means that a port of the program doesn't
344# exist yet.
345
346noconfigdirs=""
347
348case "${host}" in
349 i[345]86-*-vsta)
350 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache"
351 ;;
352 i[345]86-*-go32)
353 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache"
354 ;;
355 *-*-cygwin32)
356 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache"
357 ;;
358 ppc*-*-pe)
359 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache"
360 ;;
361esac
362
363
364case "${target}" in
365 *-*-netware)
366 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
367 ;;
368 *-*-vxworks*)
369 noconfigdirs="$noconfigdirs target-newlib"
370 ;;
371 *-*-ose)
372 noconfigdirs="$noconfigdirs target-libgloss"
373 ;;
374 alpha-dec-osf*)
375 # ld works, but does not support shared libraries. emacs doesn't
376 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
377 # gas doesn't generate exception information.
378 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
379 ;;
380 alpha*-*-*)
381 # newlib is not 64 bit ready
382 noconfigdirs="$noconfigdirs target-newlib"
383 ;;
384# start-sanitize-arc
385 arc-*-*)
386 ;;
387# end-sanitize-arc
388 arm-*-pe*)
389 ;;
390 arm-*-riscix*)
391 noconfigdirs="$noconfigdirs ld"
392 ;;
393 h8300*-*-* | \
394 h8500-*-*)
395 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
396 ;;
397 hppa*-*-*elf* | \
398 hppa*-*-lites*)
399 # Do configure ld/binutils/gas for this case.
400 ;;
401 hppa*-*-*)
402 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
403 # cc is gcc, and on any system a user should be able to link cc to
404 # whatever they want. FIXME, emacs emacs19).
405 case "${CC}" in
406 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
407 *) ;;
408 esac
409 noconfigdirs="$noconfigdirs ld shellutils"
410 ;;
411 i[345]86-*-go32)
412 # but don't build gdb
413 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
414 ;;
415 *-*-cygwin32)
416
417 # make/glob's configure uses some AC_TRY_RUN type tests
418 target_configdirs="$target_configdirs target-winsup"
419 noconfigdirs="$noconfigdirs tcl tk expect make"
420 # always build newlib.
421 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
422
423 # Can't build gdb for cygwin32 if not native.
424 case "${host}:${build}" in
425 *-*-cygwin32 | *-*-cygwin32:*-*-cygwin32) ;; # keep gdb
426 *) noconfigdirs="$noconfigdirs gdb"
427 esac
428
429 ;;
430 i[345]86-*-pe)
431 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
432 ;;
433 i[345]86-*-sco3.2v5*)
434 # The linker does not yet know about weak symbols in COFF,
435 # and is not configured to handle mixed ELF and COFF.
436 noconfigdirs="$noconfigdirs gprof ld"
437 ;;
438 i[345]86-*-sco*)
439 noconfigdirs="$noconfigdirs gprof"
440 ;;
441 i[345]86-*-solaris2*)
442 # The linker does static linking correctly, but the Solaris C library
443 # has bugs such that some important functions won't work when statically
444 # linked. (See man pages for getpwuid, for example.)
445 noconfigdirs="$noconfigdirs ld"
446 ;;
447 i[345]86-*-sysv4*)
448 # The SYSV4 C compiler doesn't handle Emacs correctly
449 case "${CC}" in
450 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
451 *) ;;
452 esac
453 # but that's okay since emacs doesn't work anyway
454 noconfigdirs="$noconfigdirs emacs emacs19"
455 ;;
456 powerpc-*-aix*)
457 # copied from rs6000-*-* entry
458 noconfigdirs="$noconfigdirs gprof cvs"
459 ;;
460 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
461 target_configdirs="$target_configdirs target-winsup"
462 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
463 # always build newlib.
464 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
465 ;;
466 rs6000-*-lynxos*)
467 # The CVS server code doesn't work on the RS/6000
468 # Newlib makes problems for libg++ in crosses.
469 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
470 ;;
471 rs6000-*-*)
472 noconfigdirs="$noconfigdirs gprof"
473 ;;
474 m68k-apollo-*)
475 noconfigdirs="$noconfigdirs ld binutils gprof"
476 ;;
477 mips*-*-irix5*)
478 # The GNU linker does not support shared libraries.
479 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
480 noconfigdirs="$noconfigdirs ld gprof emacs"
481 ;;
482 mips*-dec-bsd*)
483 noconfigdirs="$noconfigdirs gprof"
484 ;;
485 mips*-*-bsd*)
486 noconfigdirs="$noconfigdirs gprof"
487 ;;
488 mips*-*-*)
489 noconfigdirs="$noconfigdirs gprof"
490 ;;
491 romp-*-*)
492 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
493 ;;
494 sh-*-*)
495 case "${host}" in
496 i[345]86-*-vsta) ;; # don't add gprof back in
497 i[345]86-*-go32) ;; # don't add gprof back in
498 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
499 esac
500 ;;
501 sparc-*-sunos4*)
502 if [ x${is_cross_compiler} != xno ] ; then
503 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
504 else
505 use_gnu_ld=no
506 fi
507 ;;
508 v810-*-*)
509 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
510 ;;
511 vax-*-vms)
512 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
513 ;;
514 vax-*-*)
515 noconfigdirs="$noconfigdirs target-newlib"
516 ;;
517 *-*-lynxos*)
518 # Newlib makes problems for libg++ in crosses.
519 noconfigdirs="$noconfigdirs target-newlib"
520 ;;
521 *-*-macos* | \
522 *-*-mpw*)
523 # Macs want a resource compiler.
524 configdirs="$configdirs grez"
525 ;;
526esac
527
528# targets that need a second pass
529case "${target}" in
530 *-gm-magic*)
531 noconfigdirs="$noconfigdirs libgloss"
532 ;;
533esac
534
535# If we are building a Canadian Cross, discard tools that can not be built
536# using a cross compiler. FIXME: These tools should be fixed.
537if [ "${build}" != "${host}" ]; then
538 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
539fi
540
541# Make sure we don't let GNU ld be added if we didn't want it.
542if [ x$with_gnu_ld = xno ]; then
543 use_gnu_ld=no
544 noconfigdirs="$noconfigdirs ld"
545fi
546
547# Make sure we don't let GNU as be added if we didn't want it.
548if [ x$with_gnu_as = xno ]; then
549 use_gnu_as=no
550 noconfigdirs="$noconfigdirs gas"
551fi
552
553# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
554# $target_configdirs.
555# If we have the source for $noconfigdirs entries, add them to $notsupp.
556
557notsupp=""
558for dir in . $skipdirs $noconfigdirs ; do
559 dirname=`echo $dir | sed -e s/target-//g`
560 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
561 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
562 if [ -r $srcdir/$dirname/configure ] \
563 || [ -r $srcdir/$dirname/configure.in ]; then
564 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
565 true
566 else
567 notsupp="$notsupp $dir"
568 fi
569 fi
570 fi
571 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
572 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
573 if [ -r $srcdir/$dirname/configure ] \
574 || [ -r $srcdir/$dirname/configure.in ]; then
575 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
576 true
577 else
578 notsupp="$notsupp $dir"
579 fi
580 fi
581 fi
582done
583
584# Sometimes the tools are distributed with libiberty but with no other
585# libraries. In that case, we don't want to build target-libiberty.
586if [ -n "${target_configdirs}" ]; then
587 others=
588 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
589 if [ "$i" != "libiberty" ]; then
590 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
591 others=yes;
592 break;
593 fi
594 fi
595 done
596 if [ -z "${others}" ]; then
597 target_configdirs=
598 fi
599fi
600
601# Deconfigure all subdirectories, in case we are changing the
602# configuration from one where a subdirectory is supported to one where it
603# is not.
604if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
605 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
606 rm -f $i/Makefile
607 done
608fi
609if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
610 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
611 rm -f ${target_subdir}/$i/Makefile
612 done
613fi
614
615# Produce a warning message for the subdirs we can't configure.
616# This isn't especially interesting in the Cygnus tree, but in the individual
617# FSF releases, it's important to let people know when their machine isn't
618# supported by the one or two programs in a package.
619
620if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
621 # If $appdirs is non-empty, at least one of those directories must still
622 # be configured, or we error out. (E.g., if the gas release supports a
623 # specified target in some subdirs but not the gas subdir, we shouldn't
624 # pretend that all is well.)
625 if [ -n "$appdirs" ]; then
626 for dir in $appdirs ; do
627 if [ -r $dir/Makefile.in ]; then
628 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
629 appdirs=""
630 break
631 fi
632 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
633 appdirs=""
634 break
635 fi
636 fi
637 done
638 if [ -n "$appdirs" ]; then
639 echo "*** This configuration is not supported by this package." 1>&2
640 exit 1
641 fi
642 fi
643 # Okay, some application will build, or we don't care to check. Still
644 # notify of subdirs not getting built.
645 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
646 echo " ${notsupp}" 1>&2
647 echo " (Any other directories should still work fine.)" 1>&2
648fi
649
650# Set with_gnu_as and with_gnu_ld as appropriate.
651#
652# This is done by determining whether or not the appropriate directory
653# is available, and by checking whether or not specific configurations
654# have requested that this magic not happen.
655#
656# The command line options always override the explicit settings in
657# configure.in, and the settings in configure.in override this magic.
658#
659# If the default for a toolchain is to use GNU as and ld, and you don't
660# want to do that, then you should use the --without-gnu-as and
661# --without-gnu-ld options for the configure script.
662
663if [ x${use_gnu_as} = x ] ; then
664 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
665 with_gnu_as=yes
666 withoptions="$withoptions --with-gnu-as"
667 fi
668fi
669
670if [ x${use_gnu_ld} = x ] ; then
671 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
672 with_gnu_ld=yes
673 withoptions="$withoptions --with-gnu-ld"
674 fi
675fi
676
677if [ x${shared} = xyes ]; then
678 case "${target}" in
679 hppa*) target_makefile_frag=config/mt-papic ;;
680 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
681 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
682 esac
683fi
684
685# post-target:
686
687# Make sure that the compiler is able to generate an executable. If it
688# can't, we are probably in trouble. We don't care whether we can run the
689# executable--we might be using a cross compiler--we only care whether it
690# can be created. At this point the main configure script has set CC.
691echo "int main () { return 0; }" > conftest.c
692${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
693if [ $? = 0 ] && [ -s conftest ]; then
694 :
695else
696 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
697 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
698 rm -f conftest*
699 exit 1
700fi
701rm -f conftest*
702
703# The Solaris /usr/ucb/cc compiler does not appear to work.
704case "${host}" in
705 sparc-sun-solaris2*)
706 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
707 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
708 could_use=
709 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
710 if [ -d /opt/cygnus/bin ] ; then
711 if [ "$could_use" = "" ] ; then
712 could_use="/opt/cygnus/bin"
713 else
714 could_use="$could_use or /opt/cygnus/bin"
715 fi
716 fi
717 if [ "$could_use" = "" ] ; then
718 echo "Warning: compilation may fail because you're using"
719 echo "/usr/ucb/cc. You should change your PATH or CC "
720 echo "variable and rerun configure."
721 else
722 echo "Warning: compilation may fail because you're using"
723 echo "/usr/ucb/cc, when you should use the C compiler from"
724 echo "$could_use. You should change your"
725 echo "PATH or CC variable and rerun configure."
726 fi
727 fi
728 ;;
729esac
730
731# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
732# binutils tools will find libbfd.so.
733if [ "${shared}" = "yes" ]; then
734 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
735 Makefile > Makefile.tem
736 rm -f Makefile
737 mv -f Makefile.tem Makefile
738
739 case "${host}" in
740 *-*-hpux*)
741 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
742 Makefile > Makefile.tem
743 rm -f Makefile
744 mv -f Makefile.tem Makefile
745 ;;
746 esac
747fi
748
749# Record target_configdirs and the configure arguments in Makefile.
750target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
751targargs=`echo "${arguments}" | \
752 sed -e 's/--norecursion//' \
753 -e 's/--cache[a-z-]*=[^ ]*//' \
754 -e 's/--ho[a-z-]*=[^ ]*//' \
755 -e 's/--ta[a-z-]*=[^ ]*//'`
756
757# Passing a --with-cross-host argument lets the target libraries know
758# whether they are being built with a cross-compiler or being built
759# native. However, it would be better to use other mechanisms to make the
760# sorts of decisions they want to make on this basis. Please consider
761# this option to be deprecated. FIXME.
762if [ x${is_cross_compiler} = xyes ]; then
763 targargs="--with-cross-host=${host_alias} ${targargs}"
764fi
765
766targargs="--host=${target_alias} ${targargs}"
767sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
768 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
769 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
770 Makefile > Makefile.tem
771rm -f Makefile
772mv -f Makefile.tem Makefile
773
774#
775# Local Variables:
776# fill-column: 131
777# End:
778#
This page took 0.028421 seconds and 4 git commands to generate.